let htmlConceptos = "";
function getColumns() {
    let columns = [
        {
            title: `N°`,
            data: `sede_id`,
            className: 'text-center'
        },
        {
            title: `SEDE`,
            data: `sede_descripcion`,
            className: `text-center`,
        },
        {
            title: `CONCEPTO`,
            data: `montoamanecida_descripcion`,
            className: 'text-center',
            render: (data) => {
                if (data === null) {
                    return "-";
                } else {
                    return data;
                }
            }
        },
        {
            title: 'ESTADO',
            data: `estado`,
            className: "text-center",
            render: (data) => {
                let label = "";
                let contenido = "";

                if (data === 1) {
                    label = `label label-success`;
                    contenido = "ACTIVO";
                } else if (data === 0) {
                    label = `label label-danger`;
                    contenido = "INACTIVO";
                } else if (data === null) {
                    label = `label label-primary`;
                    contenido = `NO TIENE ASIGNADO`;
                }

                return `<span class="${label}">${contenido}</span>`;
            }
        },
        {
            title: `ACCIONES`,
            data: `estado`,
            className: 'text-center',
            render: (data) => {
                let registrar = "";
                let editar = "";
                let eliminar = "";

                if (data === null) {
                    registrar = `<span data-toggle="modal" data-target="#modal_entrada_pendiente" data-placement="left" title="Editar" style="cursor: pointer"> <i class='registrar icon-plus-circle2 text-success-700'></i>&nbsp;&nbsp; </span>`;
                } else {
                    editar = `<span data-placement="left" title="Editar" style="cursor: pointer"> <i class="editar icon-pencil text-slate-800"></i>&nbsp;&nbsp; </span>`;
                    eliminar = `<span data-placement="left" title="Eliminar" style="cursor: pointer"> <i class="eliminar icon-cancel-circle2 text-danger-700"></i>&nbsp;&nbsp; </span>`;
                }
                let acciones = registrar + editar + eliminar;
                return acciones;
            }
        }
    ];

    return columns;
}

function getColumnDefs() {
    let columnDefs = [
        {orderable: false, width: '3%', targets: 0, className: "text-center"},
        {orderable: false, width: '10%', targets: 1, className: "text-center"},
        {orderable: false, width: '30%', targets: 2, className: "text-center"},
        {orderable: false, width: '7%', targets: 3, className: "text-center"},
        {orderable: false, width: '7%', targets: 4, className: "text-center"},
    ];
    return columnDefs;
}

function inicializarInputsModal(data = {}){
    debugger
    $("#spanSede").html(data.sede_descripcion);
    $("#cboEditarConceptos").html(htmlConceptos);
    $("#cboEditarConceptos").val(data.montoamanecidas_id);
//    $("#txtEditarMonto12h").val(data.monto12h);
//    $("#txtEditarMonto24h").val(data.monto24h);
//    debugger
}

function mostrarMensajeResultadoModal(result = {}){
    if (result.value) {
        swal({
            type: 'success',
            title: '¡Se realizó la actualización correctamente!',
            showConfirmButton: false,
            timer: 1500
        });
}
}

function mostrarModalEdicion(data = {}) {
    axios.get("modals/policias/mantenimientoSedes/editarConceptoSede.jsp").then((response) => {
        swal({
            title: '<strong>Editar</strong>',
            html: response.data,
            showCloseButton: true,
            showCancelButton: true,
            focusConfirm: false,
            confirmButtonText: '<i class="fa fa-thumbs-up"></i> Guardar cambios',
            confirmButtonAriaLabel: 'Thumbs up, great!',
            cancelButtonText: 'Cancelar',
            cancelButtonAriaLabel: 'Thumbs down',
            width: '15%',
            onOpen: () => {
                inicializarInputsModal(data);
            }
        }).then((result) => {
            mostrarMensajeResultadoModal(result);
        });
    });
}

function mostrarModalEliminacion(data) {
    swal({
        type: 'success',
        title: '¡Eliminado correctamente!',
        showConfirmButton: false,
        timer: 1500
    });
}



function listarAsignacionesConceptosSede(objParams = {}) {
    axios.get(URI_POLICIA_CONCEPTOSEDES, objParams).then((response) => {
        response.data = formatResponse(response);
        let columns = getColumns();
        let columnDefs = getColumnDefs();

        let wrapsNameDatatable = `divDatatable`;
        let classNameForDatatable = `display table table-bordered`;
        let footer = false;

        makeDatatable(
                {
                    data: response.data.data,
                    columns,
                    columnDefs,
                    wrapsNameDatatable,
                    classNameForDatatable,
                    footer
                }
        ).then((datatable) => {
            $(datatable).on("click", ".editar", function () {
                let data = $(datatable).DataTable().row($(this).parents("tr")).data();
                mostrarModalEdicion(data);
            });

            $(datatable).on("click", ".eliminar", function () {
                let data = $(datatable).DataTable().row($(this).parents("tr")).data();
                mostrarModalEliminacion(data);
            });
        });
    });
}
function listarSedes(selectorName) {
    axios.get(URI_SEDES).then((result) => {
        let sedes = result.data;
        sedes = _.orderBy(sedes, s => s.descripcion);
        let html = `<option value="">[TODOS]</option>`;
        sedes.forEach(sede => html += `<option value="${sede.codigo}">${sede.descripcion}</option>`);
        $(selectorName).html(html);
        $('.select-search').select2();
    });
}

function listarConceptos(selectorName) {
    axios.get(URI_POLICIA_MONTOS_AMANECIDAS).then((response) => {
        let data = response.data;
        data = _.orderBy(data, d => d.descripcion);
        let html = `<option value="">[TODOS]</option>`;
        data.forEach(amanecida => htmlConceptos = html += `<option value="${amanecida.id}">${amanecida.descripcion}</option>`);
        $(selectorName).html(html);
        $('.select-search').select2();
    });
}

function buscar() {
    debugger
    let sede_id = $("#cboSedes").val();
    let montoamanecidas_id = $("#cboConceptos").val();

    let params = {
        sede_id,
        montoamanecidas_id
    };

    listarAsignacionesConceptosSede({params});
}


function registrar() {
    let
}


$().ready(function () {
    defaultConfigDataTable();
    listarSedes("#cboSedes");
    listarConceptos("#cboConceptos");
    $("#btnVerTodos").click(listarAsignacionesConceptosSede);
    $("#btnFiltro").click(buscar);
    $("#btnNuevo").click(registrar);
}
);